
{$A+,B-,D+,F+,G+,I+,K+,L+,N+,P+,Q+,R+,S+,T+,V+,W+,X+,Y+}
{.$M 16384,8192}

(*
  Nov  4, 1996 Fix for stuck on bar
  Nov  4, 1996 Fix for counting gammons and backgammons scores wrong
  Nov 11, 1996 Fix for phantom stones appearing and disappearing
*)

unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Grids, Buttons, StdCtrls, WinDlg, About,
  IniFiles;

type
  TStone = (None, Red, Blue);
  Players = (RedPlayer, BluePlayer);

const
  OpeningMax = 24;

type
  TOpeningMove = array[1..OpeningMax] of record
    Roll1 : integer;
    Roll2 : integer;
    Move1 : integer;
    Move2 : integer;
  end;

const
  OpeningMoves : TOpeningMove = (
   (Roll1 : 6;
    Roll2 : 5;
    Move1 : 1;
    Move2 : 7),

   (Roll1 : 6;
    Roll2 : 4;
    Move1 : 1;
    Move2 : 7),

   (Roll1 : 6;
    Roll2 : 3;
    Move1 : 1;
    Move2 : 7),

   (Roll1 : 6;
    Roll2 : 2;
    Move1 : 1;
    Move2 : 7),

   (Roll1 : 6;
    Roll2 : 1;
    Move1 : 12;
    Move2 : 17),

   (Roll1 : 5;
    Roll2 : 4;
    Move1 : 12;
    Move2 : 12),

   (Roll1 : 5;
    Roll2 : 3;
    Move1 : 12;
    Move2 : 12),

   (Roll1 : 5;
    Roll2 : 2;
    Move1 : 12;
    Move2 : 12),

   (Roll1 : 5;
    Roll2 : 1;
    Move1 : 12;
    Move2 : 1),

   (Roll1 : 4;
    Roll2 : 6;
    Move1 : 1;
    Move2 : 5),

   (Roll1 : 4;
    Roll2 : 3;
    Move1 : 12;
    Move2 : 12),

   (Roll1 : 4;
    Roll2 : 2;
    Move1 : 17;
    Move2 : 19),

   (Roll1 : 4;
    Roll2 : 1;
    Move1 : 12;
    Move2 : 1),

   (Roll1 : 3;
    Roll2 : 6;
    Move1 : 1;
    Move2 : 4),

   (Roll1 : 3;
    Roll2 : 2;
    Move1 : 12;
    Move2 : 12),

   (Roll1 : 3;
    Roll2 : 1;
    Move1 : 17;
    Move2 : 19),

   (Roll1 : 2;
    Roll2 : 6;
    Move1 : 1;
    Move2 : 3),

   (Roll1 : 2;
    Roll2 : 1;
    Move1 : 12;
    Move2 : 1),

   (Roll1 : 6;
    Roll2 : 6;
    Move1 : 12;
    Move2 : 1),

   (Roll1 : 5;
    Roll2 : 5;
    Move1 : 17;
    Move2 : 12),

   (Roll1 : 4;
    Roll2 : 4;
    Move1 : 12;
    Move2 : 1),

   (Roll1 : 3;
    Roll2 : 3;
    Move1 : 17;
    Move2 : 1),

   (Roll1 : 2;
    Roll2 : 2;
    Move1 : 1;
    Move2 : 3),

   (Roll1 : 1;
    Roll2 : 1;
    Move1 : 19;
    Move2 : 17));

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    NewBtn: TSpeedButton;
    Timer1: TTimer;
    AboutBtn: TSpeedButton;
    HelpBtn: TSpeedButton;
    VersusPCBtn: TSpeedButton;
    VersusHumanBtn: TSpeedButton;
    Label1: TLabel;
    Scores: TGroupBox;
    Label2: TLabel;
    BlueWinsLbl: TLabel;
    Label3: TLabel;
    RedWinsLbl: TLabel;
    ClearBtn: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SaveImage: TImage;
    Panel2: TPanel;
    Board: TImage;
    MaskImage: TImage;
    BlueStone: TImage;
    Dice1: TImage;
    Dice2: TImage;
    Dice3: TImage;
    Dice4: TImage;
    Dice5: TImage;
    Dice6: TImage;
    RedStone: TImage;
    Moves: TGroupBox;
    SpeedButton2: TSpeedButton;
    MovesLbl: TLabel;
    ScrollBar1: TScrollBar;
    function  CkBar(APoint : integer) : integer;
    function  CkHome(Apoint : integer) : integer;
    function  CanBearBlue(Apoint, Dice : integer) : boolean;
    function  CanBearRed(Apoint, Dice : integer) : boolean;
    function  BlueBlot(APoint : integer) : boolean;
    function  RedBlot(APoint : integer) : boolean;
    function  BluePoint(APoint : integer) : boolean;
    function  RedPoint(APoint : integer) : boolean;
    function  LeaveDirectShot(FromPoint, ToPoint : integer) : boolean;
    function  DirectShot(APoint, Count : integer) : boolean;
    function  OpeningMove : boolean;
    function  CanBearOff : boolean;
    procedure GetOffBar;
    function  RunGame : boolean;
    function  HitHomeBlot(APoint : integer) : boolean;
    function  CanMakePoint(APoint, DontBreakPoint : integer) : boolean;
    function  CanHit(APoint : integer) : boolean;
    function  CanHitAndPass(APoint : integer) : boolean;
    function  CanPassAndHit(APoint : integer) : boolean;
    function  CanAdvanceAnchor(APoint : integer) : boolean;
    function  CanBlock : boolean;
    function  CanRunBlot(APoint : integer) : boolean;
    function  CanCoverBlotOne(APoint : integer) : boolean;
    function  CanCoverBlotTwo(APoint : integer) : boolean;
    function  CanMakeBuilder : boolean;
    function  CanRunSafeTwoDice : boolean;
    function  CanRunSafeOneDice : boolean;
    function  CanRun : boolean;
    procedure Computer;
    procedure UpdateWins;
    procedure CkWinner;
    procedure NextTurn;
    procedure CkAllHome;
    function  StuckOnBar : boolean;
    procedure NoMoves;
    function  CanClearPoint : boolean;
    function  CanMove : boolean;
    procedure UpdateMoves;
    procedure DrawDice;
    procedure RollDice;
    procedure XYToPoint(X, Y : integer; var APoint : integer);
    procedure StoneToXY(APoint, Count : integer; var x, y : integer);
    procedure DrawHomeStones(APoint : integer);
    procedure DrawStone(X, Y : integer; Stone : TStone);
    procedure DrawStones(APoint : integer);
    procedure DrawPoint(APoint : integer);
    procedure DrawBoard;
    procedure Timer1Timer(Sender: TObject);
    procedure UpdatePlayer;
    procedure NewGame;
    procedure FormCreate(Sender: TObject);
    procedure NewBtnClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ModeBtnClick(Sender: TObject);
    procedure AboutBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure BoardMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BoardDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure BoardDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure BoardEndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure VersusPCBtnClick(Sender: TObject);
    procedure VersusHumanBtnClick(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ScrollBar1Change(Sender: TObject);
  private
    { Private declarations }
    Points : array [-1..26] of record
      Stone : TStone;
      Count : integer;
    end;

    StoneMoved : TStone;
    StonePoint : integer;

    MovesCount : integer;
    Roll : array [1..4] of record
      Die : integer;
      Used : boolean;
    end;

    Index : integer;
    ComputerMove : array [1..4] of record
      FromPoint : integer;
      Roll : integer;
      ToPoint : integer;
    end;

    FirstRoll : boolean;

    LegalMoves : array [1..4] of record
      Point : integer;
      Roll : integer;
    end;

    OldX, OldY : integer;
    XOffset, YOffset : integer;

    WhitePoint : boolean;
    Stacking : boolean;
    AllHome : boolean;
    Winner : boolean;

    PlayerTurn : Players;
    ComputerTurn : boolean;
    ComputerMode : boolean;
    TimerCount : integer;
    ComputerIndex : integer;
    VersusStr : string[20];

    BlueWins : integer;
    RedWins : integer;
  end;

  const
    RedBar = 25;
    BlueBar = 0;
    RedHome = -1;
    BlueHome = 26;

    PointWidth = 40;
    PointHeight = 5 * PointWidth;
    FieldSize = PointWidth * 2 - 28;
    PointTip = PointHeight + FieldSize;
    PointBottom = PointTip + PointHeight;

    StoneWidth = PointWidth - 2;
    StoneHeight = StoneWidth - 6;
    StoneDepth = 6;
    StoneSpacing = StoneHeight + StoneDepth + 1;
    StackSpacing = StoneDepth + 1;
var
  MainForm: TMainForm;

implementation

{$R *.DFM}
{$R CURSORS.RES}

function TMainForm.CkBar(APoint : integer) : integer;
begin
  Result:= APoint;
  if Apoint > 24 then Result:= RedBar;
  if APoint < 1 then  Result:= BlueBar;
end;

function TMainForm.CkHome(Apoint : integer) : integer;
begin
  Result:= APoint;
  if APoint > 24 then Result:= BlueHome;
  if APoint < 1  then Result:= RedHome;
end;

function TMainForm.CanBearBlue(APoint, Dice : integer) : boolean;
var
  i : integer;
begin
  Result:= false;
  if (not AllHome) or
     (Points[APoint].Stone <> Blue) or
     (Points[Apoint].Count = 0) or
     (APoint < 25 - Dice) then exit;

  Result:= true;
  if APoint = 25 - Dice then exit;

  for i:= 19 to Apoint - 1 do
    if (Points[i].Count > 0) and
       (Points[i].Stone = Blue) then
      Result:= false;
end;

function TMainForm.CanBearRed(Apoint, Dice : integer) : boolean;
var
  i : integer;
begin
  Result:= false;
  if (not AllHome) or
     (Points[APoint].Stone <> Red) or
     (Points[Apoint].Count = 0) or
     (APoint > Dice) then exit;

  Result:= true;
  if APoint = Dice then exit;

  for i:= Apoint + 1 to 6 do
    if (Points[i].Count > 0) and
       (Points[i].Stone = Red) then
      Result:= false;
end;

function TMainForm.BlueBlot(APoint : integer) : boolean;
begin
  if (Points[APoint].Stone = Blue) and
     (Points[Apoint].Count = 1) then
    Result:= true
  else
    Result:= false;
end;

function TMainForm.RedBlot(APoint : integer) : boolean;
begin
  if (Points[APoint].Stone = Red) and
     (Points[Apoint].Count = 1) then
    Result:= true
  else
    Result:= false;
end;

function TMainForm.BluePoint(APoint : integer) : boolean;
begin
  if (Points[APoint].Stone = Blue) and
     (Points[Apoint].Count > 1) then
    Result:= true
  else
    Result:= false;
end;

function TMainForm.RedPoint(APoint : integer) : boolean;
begin
  if (Points[APoint].Stone = Red) and
     (Points[Apoint].Count > 1) then
    Result:= true
  else
    Result:= false;
end;

function TMainForm.LeaveDirectShot(FromPoint, ToPoint : integer) : boolean;
var
  i : integer;
begin
  Result:= false;
  if Points[FromPoint].Count <> 2 then
    exit;

  for i:= 1 to 6 do
    if (FromPoint + i <> ToPoint) and
       (Points[CkBar(FromPoint + i)].Stone = Red) then
      Result:= true;
end;

function TMainForm.DirectShot(APoint, Count : integer) : boolean;
var
  i : integer;
begin
  Result:= false;
  if Points[APoint].Count <> Count then
    exit;

  for i:= 1 to 6 do
    if Points[CkBar(APoint + i)].Stone = Red then
      Result:= true;
end;

function TMainForm.OpeningMove : boolean;
var
  i, j, k, m, n : integer;
begin
  Result:= false;

  for j:= 1 to OpeningMax do
    for i:= 1 to 2 do
      if (OpeningMoves[j].Roll1 = Roll[i].Die) and
         (OpeningMoves[j].Roll2 = Roll[3 - i].Die) then
      begin
        k:= OpeningMoves[j].Move1 + Roll[i].Die;
        m:= OpeningMoves[j].Move2 + Roll[3 - i].Die;

        if (not RedPoint(k)) and
           (not RedPoint(m)) then
        begin
          Index:= 0;
          if Roll[1].Die = Roll[2].Die then
            n:= 2  {doubles}
          else
            n:= 1; {not doubles}

          for i:= 1 to n do
          begin
            inc(Index);
            ComputerMove[Index].FromPoint:= OpeningMoves[j].Move2;
            ComputerMove[Index].Roll:= 3 - i;
            ComputerMove[Index].ToPoint:= m;
          end;

          for i:= 1 to n do
          begin
            inc(Index);
            ComputerMove[Index].FromPoint:= OpeningMoves[j].Move1;
            ComputerMove[Index].Roll:= i;
            ComputerMove[Index].ToPoint:= k;
          end;

          Result:= true;
          Timer1.Enabled:= true;
          exit;
        end;
        break;
      end;
end;

function TMainForm.CanBearOff : boolean;
var
  i, j : integer;
begin
  Result:= true;

  for j:= 20 to RedBar do
  begin
    if Points[j].Stone = Red then
    begin
      for i:= 19 to j do
        begin
          if CanRunBlot(i) then exit;
          if CanCoverBlotOne(i) then exit;
          if CanCoverBlotTwo(i) then exit;
        end;
      for i:= 1 to 4 do
        if (Roll[i].Used = false) and
           (BlueHome - Roll[i].Die < j) then
        begin
          if (CanClearPoint) or
            ((j <> RedBar) and
            ((CanMakePoint(j, 18)) or
             (CanRunSafeTwoDice) or
             (CanRunSafeOneDice) or
             (CanHit(j)))) then
            exit;
          break;
        end;
      break;
    end;
  end;

  Result:= false;

  for i:= 1 to 4 do
    if Roll[i].Used = false then
      for j:= 19 to 24 do
        if CanBearBlue(j, Roll[i].Die) then
        begin
          ComputerMove[1].FromPoint:= j;
          ComputerMove[1].Roll:= i;
          ComputerMove[1].ToPoint:= BlueHome;
          Index:= 1;
          Result:= true;
          Timer1.Enabled:= true;
          exit;
        end;
end;

procedure TMainForm.GetOffBar;
var
  i, j, k : integer;
begin
  for j:= 1 to 3 do
    for i:= 1 to 4 do
      if Roll[i].Used = false then
      begin
        k:= Roll[i].Die;
        if ((j = 1) and {1st try to hit blot or cover}
           ((RedBlot(k)) or
            (BlueBlot(k)))) or

           ((j = 2) and {2nd try to slot for advance anchor}
            (Points[k].Count = 0)) or

           ((j = 3) and {3rd try just get off}
            (not RedPoint(k))) then
        begin
          ComputerMove[1].FromPoint:= BlueBar;
          ComputerMove[1].Roll:= i;
          ComputerMove[1].ToPoint:= k;
          Index:= 1;
          Timer1.Enabled:= true;
          exit;
        end;
      end;
end;

function TMainForm.RunGame : boolean;
var
  i, j : integer;
begin
  Result:= true;

  for i:= BlueBar to 24 do
    if Points[i].Stone = Blue then
      break;
  for j:= i to RedBar do
    if Points[j].Stone = Red then
    begin
      Result:= false;
      break;
    end;
end;

function TMainForm.HitHomeBlot(APoint : integer) : boolean;
var
  i, k : integer;
begin
  Result:= false;

  if (RedBlot(APoint)) then
    for i:= 1 to 4 do
      if (Roll[i].Used = false) then
      begin
        k:= APoint - Roll[i].Die;
        if (k > -1) and
          (Points[k].Stone = Blue) then
        begin
          ComputerMove[1].FromPoint:= k;
          ComputerMove[1].Roll:= i;
          ComputerMove[1].ToPoint:= APoint;
          Index:= 1;
          Result:= true;
          Timer1.Enabled:= true;
          exit;
        end;
      end;
end;

function TMainForm.CanMakePoint(APoint, DontBreakPoint : integer) : boolean;
var
  i, j, k, m : integer;
begin
  Result:= false;
  if (RedPoint(APoint)) or
     (BluePoint(APoint)) then
    exit;

  for i:= 1 to 4 do
    if (Roll[i].Used = false) then
    begin
      k:= APoint - Roll[i].Die;
      if (k > -1) and
         (Points[k].Stone = Blue) then
        for j:= 1 to 4 do
          if (j <> i) and
             (Roll[j].Used = false) then
          begin
            m:= APoint - Roll[j].Die;
            if (m > -1) and
               (Points[m].Stone = Blue) then
              if ((Roll[i].Die <> Roll[j].Die) and
                  (not LeaveDirectShot(k, Apoint)) and
                  (not LeaveDirectShot(m, APoint)) and
                 ((k < DontBreakPoint) or
                  (Points[k].Count > 2)) and
                 ((m < DontBreakPoint) or
                  (Points[m].Count > 2))) or

                 ((Roll[i].Die = Roll[j].Die) and
                  (Points[m].Count > 1) and
                  (not LeaveDirectShot(k, Apoint)) and
                  (not LeaveDirectShot(m, APoint)) and
                 ((m < DontBreakPoint) or
                  (Points[m].Count > 3))) then
              begin
                ComputerMove[1].FromPoint:= k;
                ComputerMove[1].Roll:= i;
                ComputerMove[1].ToPoint:= APoint;

                ComputerMove[2].FromPoint:= m;
                ComputerMove[2].Roll:= j;
                ComputerMove[2].ToPoint:= APoint;

                Index:= 2;
                Result:= true;
                Timer1.Enabled:= true;
                exit;
              end;
          end;
    end;
end;

function TMainForm.CanHit(APoint : integer) : boolean;
var
  i, k : integer;
begin
  Result:= false;
  if not RedBlot(APoint) then exit;

  for i:= 1 to 4 do
    if (Roll[i].Used = false) then
    begin
      k:= APoint - Roll[i].Die;
      if (k > -1) and
         (Points[k].Stone = Blue) and
         (not LeaveDirectShot(k, APoint)) then
      begin
        ComputerMove[1].FromPoint:= k;
        ComputerMove[1].Roll:= i;
        ComputerMove[1].ToPoint:= APoint;
        Index:= 1;
        Result:= true;
        Timer1.Enabled:= true;
        exit;
      end;
    end;
end;

function TMainForm.CanHitAndPass(APoint : integer) : boolean;
var
  i, j, k, m : integer;
begin
  Result:= false;
  if not RedBlot(APoint) then exit;

  for i:= 1 to 4 do
    if (Roll[i].Used = false) then
    begin
      k:= APoint - Roll[i].Die;
      if (k > -1) and
         (Points[k].Stone = Blue) then
      begin
        for j:= 1 to 4 do
          if (j <> i) and
             (Roll[j].Used = false) then
          begin
            m:= Apoint + Roll[j].Die;
            if (m < 25) and
               (not RedPoint(m)) then
            begin
              ComputerMove[1].FromPoint:= APoint;
              ComputerMove[1].Roll:= j;
              ComputerMove[1].ToPoint:= m;

              ComputerMove[2].FromPoint:= k;
              ComputerMove[2].Roll:= i;
              ComputerMove[2].ToPoint:= APoint;

              Index:= 2;
              Result:= true;
              Timer1.Enabled:= true;
              exit;
            end;
          end;
      end;
    end;
end;

function TMainForm.CanPassAndHit(APoint : integer) : boolean;
var
  i, j, k, m : integer;
begin
  Result:= false;
  if not RedBlot(APoint) then exit;

  for i:= 1 to 4 do
    if (Roll[i].Used = false) then
    begin
      k:= APoint - Roll[i].Die;
      if (k > -1) and
         (not RedPoint(k)) then
      begin
        for j:= 1 to 4 do
          if (j <> i) and
             (Roll[j].Used = false) then
          begin
            m:= k - Roll[j].Die;
            if (m > -1) and
               (Points[m].Stone = Blue) then
            begin
              ComputerMove[1].FromPoint:= k;
              ComputerMove[1].Roll:= i;
              ComputerMove[1].ToPoint:= APoint;

              ComputerMove[2].FromPoint:= m;
              ComputerMove[2].Roll:= j;
              ComputerMove[2].ToPoint:= k;

              Index:= 2;
              Result:= true;
              Timer1.Enabled:= true;
              exit;
            end;
          end;
      end;
    end;
end;

function TMainForm.CanAdvanceAnchor(APoint : integer) : boolean;
var
  i, j, k, m : integer;
begin
  Result:= false;
  if (RedPoint(APoint)) or
     (BluePoint(APoint)) then
    exit;

  for i:= 1 to 4 do
    if (Roll[i].Used = false) then
    begin
      k:= APoint - Roll[i].Die;
      if (k > -1) and
         (Points[k].Stone = Blue) then
        for j:= 1 to 4 do
          if (j <> i) and
             (Roll[j].Used = false) then
          begin
            m:= APoint - Roll[j].Die;
            if (m > -1) and
               (Points[m].Stone = Blue) and

             (((Roll[i].Die = Roll[j].Die) and
               (Points[m].Count > 1)) or
               (Roll[i].Die <> Roll[j].Die)) then
            begin
              ComputerMove[1].FromPoint:= k;
              ComputerMove[1].Roll:= i;
              ComputerMove[1].ToPoint:= APoint;

              ComputerMove[2].FromPoint:= m;
              ComputerMove[2].Roll:= j;
              ComputerMove[2].ToPoint:= APoint;

              Index:= 2;
              Result:= true;
              Timer1.Enabled:= true;
              exit;
            end;
          end;
    end;
end;

function TMainForm.CanClearPoint : boolean;
var
  i, j, k, m, n, p : integer;
begin
  Result:= false;

  for j:= 1 to 24 do
    if (Points[j].Stone = Blue) and
       (Points[j].Count <> 3) and
       (Points[j].Count <> 1) then
    begin
      if (not AllHome) and
         (j > 18) then
        exit;
      p:= j;
      for i:= 1 to 4 do
        if Roll[i].Used = false then
        begin
          k:= j + Roll[i].Die;
          if (k < 25) and
             (not RedPoint(k)) and
             (not DirectShot(k, 0)) then
            for m:= 1 to 4 do
            begin
              if (m <> i) and
                 (Roll[m].Used = false) then
              begin
                n:= j + Roll[m].Die;
                if (n < 25) and
                   (not RedPoint(n)) and
                   (not DirectShot(n, 0)) then
                begin
                  ComputerMove[1].FromPoint:= j;
                  ComputerMove[1].Roll:= m;
                  ComputerMove[1].ToPoint:= n;

                  ComputerMove[2].FromPoint:= j;
                  ComputerMove[2].Roll:= i;
                  ComputerMove[2].ToPoint:= k;

                  Index:= 2;
                  Result:= true;
                  Timer1.Enabled:= true;
                  exit;
                end;
              end;
            end;
        end;
      if p < 13 then
        break; {clear farthest point away if not almost home}
    end;
end;

function TMainForm.CanBlock : boolean;
var
  i, j, k : integer;
begin
  Result:= false;

  for i:= 18 to 25 do
    if Points[i].Stone = Red then
      break;
  k:= i - 2;             {not too deep}
  if k = 23 then k:= 24; {no red stone}
  if k < 22 then k:= i;  {advanced red}
  for j:= i - 6 to k do
    if CanMakePoint(j, i - 6) then
    begin
      Result:= true;
      Timer1.Enabled:= true;
      exit;
    end;
end;

function TMainForm.CanRunBlot(APoint : integer) : boolean;
var
  i, k : integer;
begin
  Result:= false;
  if not BlueBlot(APoint) then
    exit;

  for i:= 1 to 4 do
    if (Roll[i].Used = false) then
    begin
      k:= APoint + Roll[i].Die;
      if (k < 25) and
         (not RedPoint(k)) then
      begin
        ComputerMove[1].FromPoint:= APoint;
        ComputerMove[1].Roll:= i;
        ComputerMove[1].ToPoint:= k;
        Index:= 1;
        Result:= true;
        Timer1.Enabled:= true;
        exit;
      end;
    end;
end;

function TMainForm.CanCoverBlotOne(APoint : integer) : boolean;
var
  i, k : integer;
begin
  Result:= false;
  if not BlueBlot(APoint) then
    exit;

  for i:= 1 to 4 do
    if (Roll[i].Used = false) then
    begin
      k:= APoint - Roll[i].Die;
      if (k > -1) and
         (Points[k].Stone = Blue) and
         (not LeaveDirectShot(k, APoint)) then
      begin
        ComputerMove[1].FromPoint:= k;
        ComputerMove[1].Roll:= i;
        ComputerMove[1].ToPoint:= APoint;
        Index:= 1;
        Result:= true;
        Timer1.Enabled:= true;
        exit;
      end;
    end;
end;

function TMainForm.CanCoverBlotTwo(APoint : integer) : boolean;
var
  i, j, k, m : integer;
begin
  Result:= false;
  if not BlueBlot(APoint) then
    exit;

  for i:= 1 to 4 do
    if (Roll[i].Used = false) then
    begin
      k:= APoint - Roll[i].Die;
      if (k > -1) and
         (not RedPoint(k)) then
      begin
        for j:= 1 to 4 do
          if (j <> i) and
             (Roll[j].Used = false) then
          begin
            m:= k - Roll[j].Die;
            if (m > -1) and
               (Points[m].Stone = Blue) and
               (not LeaveDirectShot(m, BlueBar)) then
            begin
              ComputerMove[1].FromPoint:= k;
              ComputerMove[1].Roll:= i;
              ComputerMove[1].ToPoint:= APoint;

              ComputerMove[2].FromPoint:= m;
              ComputerMove[2].Roll:= j;
              ComputerMove[2].ToPoint:= k;

              Index:= 2;
              Result:= true;
              Timer1.Enabled:= true;
              exit;
            end;
          end;
      end;
    end;
end;

function TMainForm.CanMakeBuilder : boolean;
var
  i, j, k : integer;
begin
  Result:= false;

  for j:= 14 to 18 do
    for i:= 1 to 4 do
      if Roll[i].Used = false then
      begin
        k:= j - Roll[i].Die;
        if (k > -1) and
           (Points[k].Stone = Blue) and
           (not RedPoint(j)) and
           (not LeaveDirectShot(k, j)) and

          ((not DirectShot(j, 0)) or
           (Points[RedBar].Count > 0)) then
        begin
          ComputerMove[1].FromPoint:= k;
          ComputerMove[1].Roll:= i;
          ComputerMove[1].ToPoint:= j;
          Index:= 1;
          Result:= true;
          Timer1.Enabled:= true;
          exit;
        end;
      end;
end;

function TMainForm.CanRunSafeTwoDice : boolean;
var
  i, j, k, m, n : integer;
begin
  Result:= false;

  for j:= 1 to 24 do
    if (Points[j].Stone = Blue) then
      for i:= 1 to 4 do
        if Roll[i].Used = false then
        begin
          k:= j + Roll[i].Die;
          if (k < 24) and
             (not RedPoint(k)) and
             (not LeaveDirectShot(j, k)) then
            for m:= 1 to 4 do
            begin
              if (m <> i) and
                 (Roll[m].Used = false) then
              begin
                n:= k + Roll[m].Die;
                if (n < 25) and
                   (not RedPoint(n)) and
                   (not DirectShot(n, 0)) then

                begin
                  ComputerMove[1].FromPoint:= k;
                  ComputerMove[1].Roll:= m;
                  ComputerMove[1].ToPoint:= n;

                  ComputerMove[2].FromPoint:= j;
                  ComputerMove[2].Roll:= i;
                  ComputerMove[2].ToPoint:= k;

                  Index:= 2;
                  Result:= true;
                  Timer1.Enabled:= true;
                  exit;
                end;
              end;
            end;
        end;
end;

function TMainForm.CanRunSafeOneDice : boolean;
var
  i, j, k : integer;
begin
  Result:=false;

  for j:= 1 to 24 do
    if (Points[j].Stone = Blue) then
      for i:= 1 to 4 do
        if Roll[i].Used = false then
        begin
          k:= j + Roll[i].Die;
          if (k < 25) and
             (not RedPoint(k)) and
             (not LeaveDirectShot(j, k)) and
             (not DirectShot(k, 0)) then
          begin
            ComputerMove[1].FromPoint:= j;
            ComputerMove[1].Roll:= i;
            ComputerMove[1].ToPoint:= k;
            Index:= 1;
            Result:= true;
            Timer1.Enabled:= true;
            exit;
          end;
        end;
end;

function TMainForm.CanRun : boolean;
var
  i, j, k : integer;
begin
  Result:= false;

  for j:= 1 to 24 do
    if (Points[j].Stone = Blue) then
      for i:= 1 to 4 do
        if Roll[i].Used = false then
        begin
          k:= j + Roll[i].Die;
          if (k < 25) and
             (not RedPoint(k)) then
          begin
            ComputerMove[1].FromPoint:= j;
            ComputerMove[1].Roll:= i;
            ComputerMove[1].ToPoint:= k;
            Index:= 1;
            Result:= true;
            Timer1.Enabled:= true;
            exit;
          end;
        end;
end;

procedure TMainForm.Computer;
var
  i, j, k : integer;
begin
  TimerCount:= 0;

  if not CanMove then exit;

  if FirstRoll then
  begin
    FirstRoll:= false;
    if OpeningMove then
      exit;
  end;

  if (AllHome) and
     (CanBearOff) then
    exit;

  if Points[BlueBar].Count > 0 then {on bar}
  begin
    if (Points[BlueBar].Count = 1) then
    begin
      if CanAdvanceAnchor(Roll[1].Die) then
      begin
        i:= ComputerMove[1].FromPoint;
        ComputerMove[1].FromPoint:= ComputerMove[2].FromPoint;
        ComputerMove[2].FromPoint:= i;
        i:= ComputerMove[1].Roll;
        ComputerMove[1].Roll:= ComputerMove[2].Roll;
        ComputerMove[2].Roll:= i;
        i:= ComputerMove[1].ToPoint;
        ComputerMove[1].ToPoint:= ComputerMove[2].ToPoint;
        ComputerMove[2].ToPoint:= i;
        exit;
      end;
      if CanAdvanceAnchor(Roll[2].Die) then
        exit;
    end;
    GetOffBar;
    exit;
  end;

  if (RunGame) and
     (CanRun) then
    exit;

  for i:= 1 to 7 do
    if HitHomeBlot(i) then
      exit;

  for i:= 1 to 18 do
    if ((RedBlot(i)) and {hit red blots}
        (CanMakePoint(i, BlueBar))) or

        (CanHit(i)) or
        (CanHitAndPass(i)) or
        (CanPassAndHit(i)) then
      exit;

  for i:= 7 downto 2 do
    if CanAdvanceAnchor(i) then
      exit;

  if CanBlock then
    exit;

  for i:= 1 to 6 do
    if (BlueBlot(i)) and {run home blot}
       (DirectShot(i, 1)) and
       (CanRunBlot(i)) then
      exit;

  for i:= 24 downto 1 do
    if (CanCoverBlotOne(i)) or
       (CanCoverBlotTwo(i)) then
      exit;

  for i:= 24 downto 7 do
    if (BlueBlot(i)) and {run blot}
       (DirectShot(i, 1)) and
       (CanRunBlot(i)) then
      exit;

  if (Roll[1].Die = Roll[2].Die) then {doubles}
    for i:= 1 to 4 do
      if Roll[i].Used = false then
        for j:= 1 to 4 do
          if (j <> i) and
            (Roll[j].Used = false) then
            for k:= 22 downto 1 do
              if CanMakePoint(k, 18 {bar point}) then
                exit;

  if CanMakeBuilder then
    exit;

  if CanClearPoint then
    exit;

  if CanRunSafeTwoDice then
      exit;

  if CanRunSafeOneDice then
    exit;

  CanRun;
end;

procedure TMainForm.UpdateWins;
begin
  BlueWinsLbl.Caption:= IntToStr(BlueWins);
  RedWinsLbl.Caption:= IntToStr(RedWins);
end;

procedure TMainForm.CkWinner;
var
  i : integer;
begin
  if Points[RedHome].Count = 15 then
  begin
    Caption := 'Backgammon ' + VersusStr;
    with TWinner.Create(Application) do
    try
      DrawBoard;
      Board.Invalidate;
      Winner:= true;

      inc(RedWins);
      Player.Caption:= 'Red won: 1 point';
      if Points[BlueHome].Count = 0 then
      begin
        inc(RedWins);
        Salutation.Caption:= 'Congratulations!';
        Player.Caption:= 'Red won a gammon: 2 points';
        for i:= 1 to 6 do
          if Points[i].Count > 0 then
            begin
              inc(RedWins);
              Player.Caption:= 'Red won a backgammon: 3 points';
              break;
            end;
      end;

      UpdateWins;
      Player.Font.Color:= clFuchsia;
      ShowModal;
    finally
      Free;
    end;
  end;

  if Points[BlueHome].Count = 15 then
  begin
    Caption := 'Backgammon ' + VersusStr;
    with TWinner.Create(Application) do
    try
      DrawBoard;
      Board.Invalidate;
      Winner:= true;

      inc(BlueWins);
      if ComputerMode then
        Salutation.Caption:= 'Computer got lucky'
      else
        Salutation.Caption:= 'Congratulations!';

      Player.Caption:= 'Blue won: 1 point';
      if Points[RedHome].Count = 0 then
      begin
        inc(BlueWins);
        Player.Caption:= 'Blue won a gammon: 2 points';
        for i:= 19 to 24 do
          if Points[i].Count > 0 then
          begin
            inc(BlueWins);
            Player.Caption:= 'Blue won a backgammon: 3 points';
            break;
          end;
      end;

      UpdateWins;
      Player.Font.Color:= clBlue;
      ShowModal;
    finally
      Free;
    end;
  end;

end;

procedure TMainForm.NextTurn;
begin
  DrawBoard;
  Board.Invalidate;

  if PlayerTurn = RedPlayer then
    PlayerTurn:= BluePlayer
  else
    PlayerTurn:= RedPlayer;

  UpdatePlayer;

  if (PlayerTurn = BluePlayer) and (ComputerMode) then
  begin
    ComputerTurn:= true;
    RollDice;
    Computer;
  end
  else
    ComputerTurn:= false;
end;

procedure TMainForm.CkAllHome;
var
  i : integer;
begin
  AllHome:= true;

  if PlayerTurn = BluePlayer then
  begin
    for i:= BlueBar to 18 do
      if Points[i].Stone = Blue then
      begin
        AllHome:= false;
        break;
      end;
  end;

  if PlayerTurn = RedPlayer then
  begin
    for i:= 7 to RedBar do
      if Points[i].Stone = Red then
      begin
        AllHome:= false;
        break;
      end;
  end;

end;

function TMainForm.StuckOnBar : boolean;
var
  i : integer;
begin
  Result:= false;

  if PlayerTurn = BluePlayer then
  begin
    if Points[BlueBar].Count > 0 then
    begin
      Result:= true;
      for i:= 1 to 4 do
        if (Roll[i].Used = false) and
           (not RedPoint(Roll[i].Die)) then
          begin
            Result:= false;
            break;
          end;
    end;
  end
  else
  begin
    if Points[RedBar].Count > 0 then
    begin
      Result:= true;
      for i:= 1 to 4 do
        if (Roll[i].Used = false) and
           (not BluePoint(RedBar - Roll[i].Die)) then
          begin
            Result:= false;
            break;
          end;
    end;
  end
end;

procedure TMainForm.NoMoves;
begin
  DrawBoard;
  DrawDice;
  Board.Invalidate;
  Board.Refresh;
  if (ComputerMode) and
     (PlayerTurn = BluePlayer) then
    MessageDlg('Computer has no moves!',
      mtInformation, [mbOK], 0)
  else
    MessageDlg('Sorry, no moves!',
      mtInformation, [mbOK], 0);
  MovesCount:= 0;
  UpdateMoves;
  NextTurn;
end;

function TMainForm.CanMove : boolean;
var
  i, j, k : integer;
  StoneToMove : TStone;
begin
  Result:= false;

  if MovesCount = 0 then
  begin
    NextTurn;
    exit;
  end;

  if StuckOnBar then
  begin
    NoMoves;
    exit;
  end;

  CkAllHome;

  if PlayerTurn = RedPlayer then
    StoneToMove:= Red
  else
    StoneToMove:= Blue;

  for j:= BlueBar to RedBar do
    if Points[j].Stone = StoneToMove then
      for i:= 1 to 4 do
        if Roll[i].Used = false then
        begin
          if StoneToMove = Red then
            k:= CkHome(j - Roll[i].Die)
          else
            k:= CkHome(j + Roll[i].Die);

          if (((Points[k].Stone = None) or
               (Points[k].Stone = StoneToMove) or
               (Points[k].Count < 2)) and
               (k <> BlueHome) and (k <> RedHome)) or

              ((StoneToMove = Red) and
               (k = RedHome) and
               (CanBearRed(j, Roll[i].Die))) or

              ((StoneToMove = Blue) and
               (k = BlueHome) and
               (CanBearBlue(j, Roll[i].Die))) then
          begin
            Result:= true;
            exit;
          end;
        end;

  NoMoves;
end;

procedure TMainForm.UpdateMoves;
var
  i : integer;
begin
  MovesLbl.Caption:= '';
  if MovesCount = 0 then exit;
  for i:= 1 to 4 do
  if Roll[i].Used = false then
    MovesLbl.Caption:=
      MovesLbl.Caption + IntToStr(Roll[i].Die) + ' ';
end;

procedure TMainForm.DrawDice;
var
  i : integer;
  XPosition : integer;
begin
  XPosition:= PointWidth * 2;
  if PlayerTurn = RedPlayer then
    XPosition:= XPosition + PointWidth * 8;

  for i:= 1 to 2 do
  begin
    with Components[FindComponent('Dice' +
      IntToStr(Roll[i].Die)).ComponentIndex]
    as TImage do
      Board.Canvas.CopyRect(Bounds(XPosition,
        PointHeight + (FieldSize - Height) div 2,
          Width, Height), Canvas, ClientRect);
    XPosition:= XPosition + PointWidth * 2;
  end;
end;

procedure TMainForm.RollDice;
begin
  Roll[1].Die:= Random(6) + 1;
  Roll[1].Used:= false;
  Roll[2].Die:= Random(6) + 1;
  Roll[2].Used:= false;

  if Roll[1].Die = Roll[2].Die then
  begin
    Roll[3].Die:= Roll[1].Die;
    Roll[3].Used:= false;
    Roll[4].Die:= Roll[1].Die;
    Roll[4].Used:= false;
    MovesCount:= 4;
  end
  else
  begin
    Roll[3].Used:= true;
    Roll[4].Used:= true;
    MovesCount:= 2;
  end;

  DrawDice;
  UpdateMoves;
end;

procedure TMainForm.XYToPoint(X, Y : integer; var APoint : integer);
begin
  {APoint = 1..24 is board;
   APoint = 0 or 25 is bar;
   APoint = -1 and 26 is home;
   APoint = 27 is no point}

  APoint:= X div PointWidth;
  if APoint = 7 then
    APoint:= 0
  else
    if (APoint < 1) or (APoint > 7) then dec(APoint);

  if (Y > PointHeight) and (Y < PointTip) then APoint:= 27;
  if Y < PointHeight then APoint:= RedBar - APoint;
end;

procedure TMainForm.StoneToXY(APoint, Count:integer; var x, y:integer);
var
  i, j : integer;
begin
  i:= APoint;
  if i > 12 then i:= RedBar - i;
  x:= i * PointWidth;
  if i > 6 then x:= x + PointWidth;
  if i = 0 then x:= PointWidth * 7;
  x:= x + (PointWidth - StoneWidth) div 2;

  i:= Count;
  if Stacking then
    Y:= 0
  else
    y:= StackSpacing;

  while i > 5 do
  begin
    y:= y - StackSpacing;
    i:= i - 5;
  end;
  if APoint < 13 then
    y:= y - i * StoneSpacing + PointBottom
  else
  begin
    j:= Points[APoint].Count;
    while j > 5 do
    begin
      y:= y + StackSpacing;
      j:= j - 5;
    end;
    y:= y + (i - 1) * StoneSpacing + 1;
  end;
end;

procedure TMainForm.DrawHomeStones(APoint : integer);
var
  x, y, i : integer;
begin
  x:= (PointWidth - StoneWidth) div 2;
  with Board.Canvas do
  begin
    Brush.Color:= clAqua;
    Pen.Color:= clAqua;
    if WhitePoint then
    begin
      Brush.Color:= clWhite;
      Pen.Color:= clWhite;
    end;

    if APoint = BlueHome then
    begin
      Rectangle(0, 0, PointWidth - 1, PointHeight);
      i:= Points[APoint].Count;
      if i > 0 then
      begin
        y:= 1;
        for i:= 1 to Points[BlueHome].Count do
        begin
          Brush.Color:= clNavy;
          Pen.Color:= clNavy;
          Ellipse(x, y, x + StoneWidth, y + StoneHeight);
          Brush.Color:= clBlue;
          Pen.Color:= clBlue;
          Ellipse(x, y + StoneDepth,
            x + StoneWidth, y + StoneHeight + StoneDepth);
          y:= y + StoneDepth + 4;
        end;
      end;

    end
    else
    begin
      Rectangle(0, PointTip, PointWidth - 1, PointBottom);
      i:= Points[RedHome].Count;
      if i > 0 then
      begin
        y:= PointBottom - StoneHeight - (i * (StoneDepth + 4)) + 3;
        for i:= 1 to Points[RedHome].Count do
        begin
          Brush.Color:= clMaroon;
          Pen.Color:= clMaroon;
          Ellipse(x, y, x + StoneWidth, y + StoneHeight);
          Brush.Color:= clFuchsia;
          Pen.Color:= clFuchsia;
          Ellipse(x, y + StoneDepth,
            x + StoneWidth, y + StoneHeight + StoneDepth);
          y:= y + StoneDepth + 4;
        end;
      end;
    end;

  end;
end;

procedure TMainForm.DrawStone(X, Y : integer; Stone : TStone);
begin
  with Board.Canvas do
  begin
    if Stone = Red then
    begin
      Brush.Color:= clMaroon;
      Pen.Color:= clMaroon;
    end
    else
    begin
      Brush.Color:= clNavy;
      Pen.Color:= clNavy;
    end;
    Ellipse(X, Y + StoneDepth, X + StoneWidth,
      Y + StoneHeight + StoneDepth);

    if Stone = Red then
    begin
      Brush.Color:= clFuchsia;
      Pen.Color:= clFuchsia;
    end
    else
    begin
      Brush.Color:= clBlue;
      Pen.Color:= clBlue;
    end;
    Ellipse(X, Y,
      X + StoneWidth, Y + StoneHeight);
  end;
end;

procedure TMainForm.DrawStones(APoint : integer);
var
  i, x, y : integer;
begin
  if Points[APoint].Stone = None then exit;

  with Board.Canvas do
  begin
    for i:= 1 to Points[APoint].Count do
    begin
      StoneToXY(APoint, i, x, y);
      DrawStone(x, y, Points[APoint].Stone);
    end;
  end;
end;

procedure TMainForm.DrawPoint(APoint : integer);
var
  x, y, i : integer;
begin
  with Board.Canvas do
  begin
    if (APoint = RedHome) or (APoint = BlueHome) then
    begin
      DrawHomeStones(APoint);
      exit;
    end;

    i:= APoint;
    if i > 12 then i:= RedBar - i;
    x:= i * PointWidth;
    if i > 6 then x:= x + PointWidth;
    if i = 0 then x:= PointWidth * 7;
    if (APoint = RedHome) or (APoint = BlueHome) then x:= 0;

    if APoint > 12 then
      y:= 0
    else
      y:= PointHeight + FieldSize div 2;

    Brush.Color:= clAqua;
    Pen.Color:= clAqua;
    if (WhitePoint) and ((APoint = BlueBar) or (APoint = RedBar)) then
    begin
      Brush.Color:= clWhite;
      Pen.Color:= clWhite;
    end;

    if i > 0 then
      Rectangle(x,
                y,
                x + PointWidth,
                y + PointHeight + FieldSize div 2)
    else        {bar}
      Rectangle(x + 1,
                y,
                x + PointWidth - 1,
                y + PointHeight + FieldSize div 2);

    if odd(APoint) then
    begin
      Brush.Color:= clGray;
      Pen.Color:= clGray;
    end
    else
    begin
      Brush.Color:= clSilver;
      Pen.Color:= clSilver;
    end;

    if WhitePoint then
    begin
      Brush.Color:= clWhite;
      Pen.Color:= clWhite;
    end;

    y:= 0;
    if (APoint <> 0) and (APoint <> RedBar) then
      if APoint > 12 then
        Polygon([Point(x, y),
                 Point(x + PointWidth, y),
                 Point(x + PointWidth Div 2, y + PointHeight)])
      else
        Polygon([Point(x, y + PointBottom),
                 Point(x + PointWidth, y + PointBottom),
                 Point(x + PointWidth Div 2, y + PointTip)]);

    DrawStones(APoint);
 end;
end;

procedure TMainForm.DrawBoard;
var
  i : integer;
begin
  with Board.Canvas do
  begin
    Brush.Color:= clAqua;
    Pen.Color:= clBlack;

    Rectangle(-1, -1, PointWidth, PointBottom + 3); {Home}

    Rectangle(PointWidth * 7, {bar}
              -1,
              PointWidth * 8,
              PointBottom + 3);

    Rectangle(-1, PointHeight, PointWidth, PointTip); {Doubling cube}
  end;

  for i:= RedHome to BlueHome do
    DrawPoint(i);
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
  if Odd(TimerCount) then
  begin
    WhitePoint:= true;
    DrawPoint(ComputerMove[Index].ToPoint);
    WhitePoint:= false;
    DrawPoint(ComputerMove[Index].FromPoint);
  end
  else
  begin
    WhitePoint:= true;
    DrawPoint(ComputerMove[Index].FromPoint);
    WhitePoint:= false;
    DrawPoint(ComputerMove[Index].ToPoint);
  end;
  DrawDice;

  inc(TimerCount);
  if TimerCount = 3 then
  begin
    Timer1.Enabled:= false;
    dec(Points[ComputerMove[Index].FromPoint].Count);
    if Points[ComputerMove[Index].FromPoint].Count = 0 then
      Points[ComputerMove[Index].FromPoint].Stone:= None;
    if Points[ComputerMove[Index].ToPoint].Stone = Red then
    begin
      dec(Points[ComputerMove[Index].ToPoint].Count);
      Points[RedBar].Stone:= Red;
      inc(Points[RedBar].Count);
    end;
    Points[ComputerMove[Index].ToPoint].Stone:= Blue;
    inc(Points[ComputerMove[Index].ToPoint].Count);
    Roll[ComputerMove[Index].Roll].Used:= true;
    dec(MovesCount);

    DrawBoard;

    UpdateMoves;
    CkWinner;
    if Winner then exit;

    dec(Index);
    if Index > 0 then
    begin
      DrawDice;
      TimerCount:= 0;
      Timer1.Enabled:= true;
      exit;
    end;

    if MovesCount > 0 then
    begin
      DrawDice;
      Computer;
    end
    else
      NextTurn;
  end;
end;

procedure TMainForm.UpdatePlayer;
begin
  if PlayerTurn = RedPlayer then
    Caption := 'Backgammon ' + VersusStr +
      ' Red Stone''s Turn'
  else
    if ComputerMode then
      Caption := 'Backgammon ' + VersusStr +
        ' Computer''s Thinking'
    else
      Caption := 'Backgammon ' + VersusStr +
        ' Blue Stone''s Turn';
end;

procedure TMainForm.NewGame;
var
  i : integer;
begin
  Timer1.Enabled:= false;

  for i:= RedHome to BlueHome do
  begin
    Points[i].Stone:= None;
    Points[i].Count:= 0;
  end;
  Points[6].Stone:=  Red; Points[6].Count:= 5;
  Points[8].Stone:=  Red; Points[8].Count:= 3;
  Points[13].Stone:= Red; Points[13].Count:= 5;
  Points[24].Stone:= Red; Points[24].Count:= 2;
  Points[1].Stone:=  Blue; Points[1].Count:= 2;
  Points[12].Stone:= Blue; Points[12].Count:= 5;
  Points[17].Stone:= Blue; Points[17].Count:= 3;
  Points[19].Stone:= Blue; Points[19].Count:= 5;

  for i:= 1 to 4 do
    Roll[i].Used:= true;
  MovesCount:= 0;

  WhitePoint:= false;
  DrawBoard;

  PlayerTurn:= RedPlayer;
  Winner:= false;
  ComputerTurn:= false;
  FirstRoll:= true;

  if ComputerMode then
    VersusStr := '(Playing Computer)'
  else
    VersusStr:= '(Two Players)';
  Caption := 'Backgammon ' + VersusStr;
  UpdatePlayer;
  UpdateMoves;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  with TIniFile.Create(ChangeFileExt(Application.ExeName, '.INI')) do
  try
    ComputerMode:= ReadBool('Options', 'Computer Mode', true);
    ComputerMode:= ReadBool('Options', 'Computer Mode', true);
    ScrollBar1.Position:= ReadInteger('Options', 'Speed', 1450);
    BlueWins:= ReadInteger('Wins', 'Blue', 0);
    RedWins:= ReadInteger('Wins', 'Red', 0);
  finally
    Free;
  end;
  ScrollBar1Change(Sender);
  if ComputerMode = false then
    VersusHumanBtn.Down:= true;
  UpdateWins;

  Screen.Cursors[crNoDrop]:= LoadCursor(hInstance, 'GRABHAND');
  Screen.Cursors[crDrag]:= LoadCursor(hInstance, 'OPENHAND');

  Stacking:= true;

  with Panel2 do
  begin
    Width:= PointWidth * 14 + 3;
    Height:= PointHeight * 2 + FieldSize + 3;
    Left:= 2;
    Top:= 0;
    Self.ClientWidth:= Width + Panel1.Width + 2;
    Self.ClientHeight:= Height + 2;
    Board.Width:= Width - 2;
    Board.Height:= Height - 2;
    Board.Left:= 0;
    Board.Top:= 0;
  end;

  Randomize;
  NewGame;
end;

procedure TMainForm.NewBtnClick(Sender: TObject);
begin
  NewGame;
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then Close;
end;

procedure TMainForm.ModeBtnClick(Sender: TObject);
begin
  if ComputerMode then
    ComputerMode:= false
  else
    ComputerMode:= true;
  NewGame;
end;

procedure TMainForm.AboutBtnClick(Sender: TObject);
begin
  with TAboutBox.Create(Application) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TMainForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTENTS, 0);
end;

procedure TMainForm.BoardMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  XCord, YCord : integer;
  i, j : integer;
  LegalMove : boolean;

  APoint : integer;
begin
  if (ComputerTurn) or (Winner) then
    exit;

  XYToPoint(X, Y, APoint);
  if Apoint > 25 then exit;

  i:= Points[APoint].Count;
  if i = 0 then exit;

  StoneToXY(APoint, i, XCord, YCord);

  if (X < XCord) or (X > XCord + StoneWidth) or
     (Y < YCord) or (Y > YCord + StoneHeight + StoneDepth) then
    exit;

  if MovesCount = 0 then
  begin
    MessageDlg('Please roll dice', mtInformation, [mbOK], 0);
    exit;
  end;

  StoneMoved:= Points[APoint].Stone;
  StonePoint:= APoint;

  if PlayerTurn = RedPlayer then
  begin
    if StoneMoved = Blue then exit;
    if ((APoint <> RedBar) and (Points[RedBar].Count > 0)) then
    begin
      MessageDlg('Have to move man off bar first', mtInformation,
        [mbOK], 0);
      exit;
    end;
  end;

  if PlayerTurn = BluePlayer then
  begin
    if StoneMoved = Red then exit;
    if ((APoint <> BlueBar) and (Points[BlueBar].Count > 0)) then
    begin
      MessageDlg('Have to move man off bar first', mtInformation,
        [mbOK], 0);
      exit;
    end;
  end;

  LegalMove:= false;

  for i:= 1 to 4 do
    if Roll[i].Used = false then
    begin
      if StoneMoved = Red then
        j:= CkHome(APoint - Roll[i].Die)
      else
        j:= CkHome(APoint + Roll[i].Die);

      if ((Points[j].Stone <> StoneMoved) and
          (Points[j].Count > 1)) or

         ((j = BlueHome) and
          (not CanBearBlue(Apoint, Roll[i].Die))) or

         ((j = RedHome) and
          (not CanBearRed(APoint, Roll[i].Die))) then

        LegalMoves[i].Point:= -27 {bogus move}
      else
        begin
          LegalMoves[i].Point:= j;
          LegalMoves[i].Roll:= i;
          LegalMove:= true;
        end;
    end
    else
      LegalMoves[i].Point:= -27;

  if not LegalMove then
  begin
    MessageDlg('Sorry, can''t move that man', mtInformation, [mbOK], 0);
    exit;
  end;

  XOffset:= XCord - X;
  YOffset:= YCord - Y;

  if (APoint > 12) and
     ((Points[APoint].Count = 6) or
      (Points[APoint].Count = 11)) then
    Stacking:= false;
  dec(Points[APoint].Count);
  DrawPoint(APoint);
  Stacking:= true;

  with SaveImage do
  begin
    Canvas.CopyRect(ClientRect, Board.Canvas,
      Bounds(XCord, YCord, ClientRect.Right, ClientRect.Bottom));
  end;

  inc(Points[APoint].Count);
  DrawPoint(APoint);
  DrawDice;

  OldX:= XCord;
  OldY:= YCord;
  Board.BeginDrag(false);
end;

procedure TMainForm.BoardDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
var
  i : integer;
  XCord, YCord : integer;
  BoardRect : TRect;

  APoint : integer;
begin
  XYToPoint(X, Y, APoint);

  Accept:= false;

  for i:= 1 to 4 do
    if APoint = LegalMoves[i].Point then
      Accept:= true;

  XCord:= X + XOffset;
  YCord:= Y + YOffset;

  with SaveImage do
  begin
    Board.Canvas.CopyRect(Bounds(OldX, OldY, ClientRect.Right,
      ClientRect.Bottom), Canvas, ClientRect);
    BoardRect:= Bounds(XCord, YCord, ClientRect.Right, ClientRect.Bottom);
    Canvas.CopyRect(ClientRect, Board.Canvas, BoardRect);
  end;

  with Board.Canvas do
  begin
    CopyMode:= cmSrcAnd;
    CopyRect(BoardRect, MaskImage.Canvas, MaskImage.ClientRect);

    CopyMode:= cmSrcPaint;
    if StoneMoved = Red then
      CopyRect(BoardRect, RedStone.Canvas, RedStone.ClientRect)
    else
      CopyRect(BoardRect, BlueStone.Canvas, BlueStone.ClientRect);

    CopyMode:= cmSrcCopy;
  end;

  OldX:= XCord;
  OldY:= YCord;
end;

procedure TMainForm.BoardDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  i : integer;
  APoint : integer;
begin
  XYToPoint(X, Y, APoint);

  if StoneMoved = Red then
  begin
    if Points[APoint].Stone = Blue then
    begin
      inc(Points[BlueBar].Count); {send to bar}
      Points[BlueBar].Stone:= Blue;
      dec(Points[APoint].Count);
    end;
  end
  else
    if Points[APoint].Stone = Red then
    begin
      inc(Points[RedBar].Count); {send to bar}
      Points[RedBar].Stone:= Red;
      dec(Points[APoint].Count);
    end;

  dec(Points[StonePoint].Count);
  if Points[StonePoint].Count = 0 then
    Points[StonePoint].Stone:= None;
  Points[APoint].Stone:= StoneMoved;
  inc(Points[Apoint].Count);

  for i:= 1 to 4 do
    if APoint = LegalMoves[i].Point then
    begin
      Roll[LegalMoves[i].Roll].Used:= true;
      dec(MovesCount);
      break;
    end;

  UpdateMoves;
  CkWinner;
  if Winner then exit;
  CanMove;
end;

procedure TMainForm.BoardEndDrag(Sender, Target: TObject; X,
  Y: Integer);
begin
  DrawBoard;
  if MovesCount > 0 then DrawDice;
end;

procedure TMainForm.VersusPCBtnClick(Sender: TObject);
begin
  ComputerMode:= true;
  NewGame;
end;

procedure TMainForm.VersusHumanBtnClick(Sender: TObject);
begin
  ComputerMode:= False;
  NewGame;
end;

procedure TMainForm.ClearBtnClick(Sender: TObject);
begin
  BlueWins:= 0;
  RedWins:= 0;
  UpdateWins;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  with TIniFile.Create(ChangeFileExt(Application.ExeName, '.INI')) do
  try
    WriteBool('Options', 'Computer Mode', ComputerMode);
    WriteInteger('Options', 'Speed', ScrollBar1.Position);
    WriteInteger('Wins', 'Blue', BlueWins);
    WriteInteger('Wins', 'Red', RedWins);
  finally
    Free;
  end;

end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
begin
      Close;
end;

procedure TMainForm.SpeedButton2Click(Sender: TObject);
begin
  if (MovesCount > 0) or (ComputerTurn) or (Winner) then
    exit;
  RollDice;
  CanMove;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:= MessageDlg('Do you wish to quit backgammon?',
    mtConfirmation, [mbYes, mbCancel], 0) = mrYes;
end;

procedure TMainForm.ScrollBar1Change(Sender: TObject);
begin
  with ScrollBar1 do
    Timer1.Interval:= Max + Min - Position;
end;

end.
